var render = require('./lib/render')
var requireDir = require('require-dir')
// var middleware = requireDir('./middleware');
var logger = require('koa-logger')
var router = require('koa-router')()
var parse = require('co-body')
var path = require('path')
var koa = require('koa')
var app = new koa()
var redis = require('./shared/redis')
var RedisToolkit = require('./shared/redis-toolkit')
var generateName = require('sillyname')

app.use(logger())

router.get('/toolkit', list)
router.get('/toolkit/add/name/:name/path/:path', add)
router.get('/toolkit/del/:id', del)
router.post('/toolkit/:id', show)


app
  .use(router.routes())
  .use(router.allowedMethods())
// route definitions

/**
 * toolKit projects listing.
 */
function *list() {
  var toolkits = yield RedisToolkit.getAll()
  console.log(toolkits)
  var html = yield render('list', { posts: toolkits })
  this.body = html
}

function *add() {
  yield RedisToolkit.add(generateName(), 'myPath')
  this.body = yield render('new')
}

function *show(id) {
  var post = posts[i]
  if(!post) this.throw(404, 'Invalid post id...')
  this.body = yield render('show', { post: post })
}

function *del() {
  var id = this.params.id
  var deleted = yield RedisToolkit.del(id)
  this.body = yield render('delete', {deleted: deleted, id: id})
}

app.listen(3000);
console.log('listening on port 3000')
